#include <stdio.h>
#import <Cocoa/Cocoa.h>

void cb_cat_string()
{
    NSAutoreleasePool *pool = [[NSAutoreleasePool alloc] init];
    NSPasteboard *pb = [NSPasteboard generalPasteboard];
    NSString *str = nil;

    str = [pb stringForType: NSStringPboardType];
    if (str) {
        printf("%s", [str cString]);
    }

    [pool release];
}

void cb_set_string(const char *src)
{
    NSAutoreleasePool *pool = [[NSAutoreleasePool alloc] init];
    NSPasteboard *pb = [NSPasteboard generalPasteboard];
    NSString *string = [[NSString alloc] initWithCString: src];
    BOOL rc;

    [pb declareTypes: [NSArray arrayWithObjects: NSStringPboardType, nil] owner: nil];
    rc = [pb setString: string forType: NSStringPboardType];
    if (rc == NO) {
        fprintf(stderr, "cannot write NSPasteboard\n");
    }

    [pool release];
}
